/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FIL                                                      */
/* Tabela : TIPOOPERACFIL                                                     */
/*                                                                            */
/* Criao:                                                                   */
/* 29/03/2010 - Wander Alex Oliveira                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FIL'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
DROP TRIGGER DTULTATU_FIL
GO

CREATE TRIGGER DTULTATU_FIL
ON TIPOOPERACFIL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOOPERACFIL', null, 'IDENTRSAIDOP='+ IDENTRSAIDOP+ ';'+
                                         'CDTIPOOPER='  + CDTIPOOPER  + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOOPERACFIL
      SET DTULTATU = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOOPERACFIL.IDLIBERADO,0)   = ISNULL(INSERTED.IDLIBERADO,0))   AND
            (ISNULL(TIPOOPERACFIL.IDLANCMANUAL,0)   = ISNULL(INSERTED.IDLANCMANUAL,0));

   END;
END;
GO
