IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE
           O.NAME = 'NFSAIDA_PESDOC' AND
	   TYPE = 'V' 		  AND
	   U.UID = O.UID          AND
	   U.NAME = USER)

   DROP VIEW NFSAIDA_PESDOC
GO


CREATE VIEW NFSAIDA_PESDOC AS
   SELECT N.CDFILIAL, N.NRLANCTONF, N.CDEMPRESA, N.CDINSCESTA, N.CDINSCMUNI, N.IDTPIJURNF,
          N.NRINSJURNF, N.CDFORNECED, N.CDCLIENTE, N.IDERROS, N.IDAVISOS, N.IDBLOQUEADO,
          N.IDDOCFISCAL, N.IDDOCFINANC, N.NRNOTAFISC, N.DTEMISSAO, N.DTENTRSAID, N.VRPRODUTOS,
          N.VRNOTAFISC, N.DTINIAPUFISC, N.DTAPROVACAO, N.CDOPERAPRO, N.DTCONTABIL, N.NRPLACAVEIC,
          N.SGUFVEIC, N.IDPGTOFRETE, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
          N.VRPBRUTOVOLU, N.VRPLIQUVOLU, N.IDENTRSAIDOP, N.CDTIPOOPER, N.CDSERIE, N.IDTPIJURTRAN,
          N.NRINSJURTRAN, N.VRTTMOEDESTR, N.CDFISOPENTF, N.DSCDFISOPENF, N.IDDOCCONTAB, N.IDSTATUS,
          N.NRLANCTBDOC, N.NRAPURACFAT, N.IDDOCFATUR, N.IDDOCFISCENT, N.IDDOCFISCSAI, N.IDDOCESTOQUE,
          N.CDSERIEEMIS, N.IDSISTEMA, N.CDMODDOCFISC, N.CDSERIEENTR, N.CDINTEGRACAO, N.CDFILIAPFATU,
          N.NRAPFATUTNF, N.NRMRDPAPUR, N.IDORIGDESTNF, N.IDDOCREPLIC, N.NRLICENCAUSO, N.CDFILIALDUP,
          N.NRLANCTODUP, N.DTSAIDEMIS, N.NRLANCTBAJUS, N.NRAVISOENTR, N.DTEXPORTACAO, N.NRNOTACRED,
          N.CDFILIMATRIC, N.CDTURMAPER, N.NRSEQTURPER, N.NRMATRICULA, N.CDFILESTAGIO, N.CDESTAGIO,
          N.CDFILIEMIT, N.CDFILIRECE, N.NRCTRLNFCMP, N.CDAUTDESPESA, N.CDALMOXARIFE, N.CDLOCALESTOQ,
          N.CDVENDEDOR, N.DTLANCAMENNF, N.DTEMISDOCUAR, N.IDGEROUTDOCU, N.NREXPEDICAO, N.CDROTATRANS,
          N.NRNOTADEVOL, N.CDOPERGERA, N.VRDEVOLNFUTL, N.DTCOMPFATUR,
          (CASE ISNULL(N.IDORIGDESTNF,'C') WHEN 'C' THEN C.NMRAZSOCCLIE ELSE
              CASE ISNULL(N.IDORIGDESTNF,'C') WHEN 'F' THEN F.NMRAZSOCFORN
                 ELSE L.NMRAZSOCFILI
              END
           END) AS NMRAZSOCNF,
          (CASE ISNULL(N.IDORIGDESTNF,'C') WHEN 'C' THEN C.NMFANTCLIE ELSE
              CASE ISNULL(N.IDORIGDESTNF,'C') WHEN 'F' THEN F.NMFANTFORN
                ELSE L.NMFILIAL
              END
           END) AS NMFANTNF
   FROM
        NOTAFISCAL N LEFT JOIN CLIENTE C
                        ON (N.CDCLIENTE    = C.CDCLIENTE)
                     LEFT JOIN FORNECEDOR F
                        ON (N.CDFORNECED   = F.CDFORNECED)
                     LEFT JOIN FILIAL L
                        ON (N.CDFILIRECE   = L.CDFILIAL)
   WHERE N.IDENTRSAIDOP = 'S'                                 AND
         N.IDSTATUS     <> 'C'                                AND
         ISNULL(N.IDSISTEMA, 'DFS') NOT IN ('ITG','REC', 'FIS')
GO